// This software including the source code and documentation (the "SOFTWARE")
// is copyrighted.  You are free to use the SOFTWARE for any non-commercial
// purpose whatsoever provided you do not remove this copyright notice.
// If you wish to use the SOFTWARE for commercial purposes, please contact us
// to obtain a license.  The SOFTWARE is provided "as is", with absolutely no
// warranty.  Use it at your own risk.
// Website: http://www.math.ie/checker.html

#ifndef _unavsets_H
#define _unavsets_H  1

#include <vector>
#include <algorithm>
#include "myset.h"
#include <string>

using namespace std;

#define xcoord(b,r,c) ((b%3)*3 + c)
#define ycoord(b,r,c) (r + b - b%3)

void FindUnavoidableSets( int A[9][9], vector< MySet >& sets, bool swapped = false );
void FindUnavoidablesGeneral( int A[9][9], vector< MySet >& sets, bool swapped = false );
void RemoveDuplicateSets( vector< MySet >& sets );
void RemoveNonUnavoidableSets( vector< MySet >& sets, char const* pszGrid );
void TestSetsForUnavoidability( vector< MySet >& sets, char const* pszGrid );
string GetUnavFilename( char const* pszGridFilename );
bool SaveUnavoidablesToFile( char const* pszUnavFilename, vector< MySet > const& sets );

#endif
